workflow:
    rules:
        - if: $CI_MERGE_REQUEST_IID
        - if: $CI_COMMIT_BRANCH =~ /^(master|develop)$/
        - if: $CI_COMMIT_TAG =~ /^v?[0-9]+[.][0-9]+([.][0-9]+)?$/
        - if: $CI_PIPELINE_SOURCE == "web"

stages: [build, test, publish]

variables:
    GIT_CLONE_PATH: '$CI_BUILDS_DIR/$CI_JOB_ID'
    FF_ENABLE_JOB_CLEANUP: 'true'

.setup:
    tags:
        - py$PY_VER
        - cuda$CUDA_VER]

.setup-windows:
    extends:
        - .setup

    tags:
        - windows
        - vs2019

    variables:
        CUDAToolkit_ROOT: C:\Program Files\NVIDIA GPU Computing Toolkit\CUDA\v$CUDA_VER_DOT
        CUDA_PATH: $CUDAToolkit_ROOT
        PATH: $PATH;$CUDA_PATH\bin"
        PYTHON: C:\Program Files\Python$PY_VER\python.exe

    before_script:
        - Import-Module "C:\Program Files (x86)\Microsoft Visual Studio\2019\BuildTools\Common7\Tools\Microsoft.VisualStudio.DevShell.dll"
        - Enter-VsDevShell -VsInstallPath "C:\Program Files (x86)\Microsoft Visual Studio\2019\BuildTools" -DevCmdArguments "-arch=x64"

.setup-linux:
    extends:
        - .setup

    tags:
        - linux

    variables:
        CUDAToolkit_ROOT: /usr/local/cuda-$CUDA_VER_DOT
        PYTHON: /usr/local/python$PY_VER_DOT/bin/python

.build:
    variables:
        GIT_DEPTH: '0' # need tags for release extraction

    artifacts:
        paths:
            - dist/vortex*.whl
            - dist/vortex*.tar.gz

    script:
        - $PYTHON -m pip wheel . -w dist -v

    after_script:
        - ls dist/vortex*

.build-windows:
    stage: build

    extends:
        - .setup-windows
        - .build

    variables:
        VORTEX_BUILD_FEATURES: WITH_ALAZAR=ON;WITH_CUDA=ON;WITH_DAQMX=ON;WITH_IMAQ=ON;WITH_HDF5=ON;WITH_REFLEXXES=ON

.build-linux:
    stage: build

    extends:
        - .setup-linux
        - .build

    variables:
        VORTEX_BUILD_FEATURES: WITH_ALAZAR=ON;WITH_CUDA=ON;WITH_DAQMX=ON;WITH_HDF5=ON;WITH_REFLEXXES=ON

.test:
    stage: test

    script:
        - $PYTHON -m pip install cupy-cuda$CUDA_VER vortex-oct-cuda$CUDA_VER -r test/requirements.txt -f dist
        - $PYTHON -m pytest test/offline --junitxml=report-py${PY_VER}-cuda${CUDA_VER}.xml

    artifacts:
        when: always
        reports:
            junit: report-*.xml

.test-windows:
    extends:
        - .test

    tags:
        - windows

    before_script:
        - $PYTHON -m venv .ve
        - .ve/Scripts/activate

.test-linux:
    extends:
        - .test

    tags:
        - linux

    before_script:
        - $PYTHON -m venv .ve
        - .ve/bin/activate

# .publish:
#     stage: publish

#     script:
#         - ls dist/vortex*.whl
#         - $PYTHON -m twine upload --repository-url $REPOSITORY dist/vortex*.whl

# publish-internal:
#     extends: .publish

#     variables:
#         TWINE_USERNAME: gitlab-ci-token
#         TWINE_PASSWORD: $CI_JOB_TOKEN
#         REPOSITORY: ${CI_API_V4_URL}/projects/${CI_PROJECT_ID}/packages/pypi

#     rules:
#         - if: $CI_COMMIT_BRANCH =~ /^(master|develop)$/
#         - if: $CI_COMMIT_TAG =~ /^v?[0-9]+[.][0-9]+([.][0-9]+)?$/
#         - if: $CI_PIPELINE_SOURCE == "web"
#           when: manual

# publish-pypi:

#     extends: .publish

#     variables:
#         TWINE_USERNAME: $PYPI_USERNAME
#         TWINE_PASSWORD: $PYPI_PASSWORD
#         REPOSITORY: $PYPI_REPOSITORY

#     rules:
#         - if: $CI_COMMIT_TAG =~ /^v?[0-9]+[.][0-9]+([.][0-9]+)?$/
#           when: manual
